struct Phd12
{
	u64_t Seed_;

	Phd12()
		: Seed_(0x48AEEFD486289CFBui64)
	{}

	Phd12(const Phd12& R)
		: Seed_(R.Seed_)
	{}

	u32_t hiDD(u64_t V)
	{
		return u32_t(V >> 0x20);
	}

	u32_t loDD(u64_t V)
	{
		return u32_t(V);
	}

	bool IsBitSet64(u64_t V, int Pos)
	{
		return (V & (u64_t(1) << Pos)) != 0;
	}

	void SetBit64(u64_t& V, int Pos)
	{
		V |= 1ui64 << Pos;
	}

	void ClrBit64(u64_t& V, int Pos)
	{
		V &= ~(1ui64 << Pos);
	}

	int BitSum64(u64_t V)
	{
		int lR = 0;
		for (int i = 0; i < 0x40; ++i)
			if (IsBitSet64(V, i)) ++lR;
		return lR;
	}

	/* Pack selected bits to word.  */
	u16_t GetWord()
	{
		u16_t lResult = 0;
		int lR0 = 1, lR1, lR2, lR3;
		u32_t i;

#if 1
		for (i = 0; i < 0x10; ++i)
		{
			if (IsBitSet64(Seed_, lR0)) lResult |= 1 << i;
			lR0 = (lR0 + 29) % 64;
		}
#else
		for (i = 0; i < 0x10; i += 4)
		{
			if (IsBitSet64(Seed_, lR0)) lResult |= 1 << i;
			lR1 = (lR0 + 29) % 64;
			if (IsBitSet64(Seed_, lR1)) lResult |= 1 << (i + 1);
			lR2 = (lR1 + 29) % 64;
			if (IsBitSet64(Seed_, lR2)) lResult |= 1 << (i + 2);
			lR3 = (lR2 + 29) % 64;
			if (IsBitSet64(Seed_, lR2)) lResult |= 1 << (i + 3);
			lR0 = (lR3 + 29) % 64;
		}
#endif
		return lResult;
	}

	/* Restore packed bits to their positions.  */
	void Update(u16_t V)
	{
		u32_t lShift = 1;
		for (int i = 0; i < 0x10; ++i)
		{
			if (V & (1 << i))
			{
				SetBit64(Seed_, lShift);
			}
			else
			{
				ClrBit64(Seed_, lShift);
			}
			lShift = (lShift + 29) % 64;
		}
	}

	void Final()
	{
		Seed_ = (Seed_ << 1) | BitSum64(Seed_ & 0x9B1ADEDF847D3481ui64);
	}

	bool Check()
	{
		u64_t lResult = 0;
		int __i = 0, lMix0, lTSize = sizeof(Table) / sizeof(Table[0]);

		pu64_t lCheckTable = Table;
		for (int t = 0; t < lTSize; t += 8)
		{
			lMix0 = 0;
			for (int j = 8; j; --j, ++lCheckTable)
			{
				if ((*lCheckTable & Seed_) == *lCheckTable) ++lMix0;
/*
				for (lShift = 0; lShift < 0x40; ++lShift)
				{
					if (IsBitSet64(*lCheckTable, lShift) && !IsBitSet64(lSeed, lShift))
							break;
				}
				if (++lShift >= 0x40) ++lMix0;
*/
			}
			if (lMix0 & 1) SetBit64(lResult, __i++);
		}
		return lResult == 0xA3FE45ADF1EC2AB4ui64;
	}

	bool Button(u8_t Idx)
	{
		u32_t lV = GetWord();
		u16_t lX;

		if (lV & (1 << Idx))
			lX = lV & ~(1 << Idx);
		else
			lX = lV | (1 << Idx);

		Update(lX);
		Final();

		return Check();
	}
};
